# [Common](@id common_header)

Core routines for creating a `Simulation` object.
Most default parameters defined as [Global Defaults](@ref).

See [Building a Simulation](@ref common_header) for tutorial.

---

Exported methods:
  * [`AbstractDielectricFunction`](@ref)
  * [`AbstractLUPACK`](@ref)
  * [`AbstractPumpFunction`](@ref)
  * [`AbstractShape`](@ref)
  * [`BCHermiticity`](@ref)
  * [`Boundary`](@ref)
  * [`cPML`](@ref)
  * [`Curlcurl`](@ref)
  * [`DEFAULT_LUPACK`](@ref)
  * [`DirichletBC`](@ref)
  * [`DispersiveDomain`](@ref)
  * [`ElectricField`](@ref)
  * [`FloquetBC`](@ref)
  * [`Hermitian`](@ref)
  * [`HermitianBC`](@ref)
  * [`Interval`](@ref)
  * [`Lattice`](@ref)
  * [`LatticeDomain`](@ref)
  * [`Lattices`](@ref)
  * [`MatchedBC`](@ref)
  * [`Maxwell`](@ref)
  * [`MSolver`](@ref)
  * [`NeumannBC`](@ref)
  * [`NondispersiveDomain`](@ref)
  * [`NonHermitianBC`](@ref)
  * [`noBC`](@ref)
  * [`noBL`](@ref)
  * [`PML`](@ref)
  * [`Point`](@ref)
  * [`PSolver`](@ref)
  * [`Simulation`](@ref)
  * [`smooth!`](@ref)
  * [`susceptability`](@ref)
  * [`Symmetric`](@ref)
  * [`TwoLevelSystem`](@ref)
  * [`Unsymmetric`](@ref)
  * [`update!`](@ref)
  * [`update_dielectric!`](@ref)
  * [`update_pump!`](@ref)
  * [`USolver`](@ref)  

---

```@docs
Common
```
---

### Global Defaults
```@autodocs
Modules = [Common]
Order = [:constant]
```
